﻿package gamespecific
{
    import flash.display.GradientType;
    import flash.geom.Matrix;
    import meyermike.constants.Colors;
    import meyermike.core.GameObject;
    import meyermike.Global;
    import meyermike.Util;
    import meyermike.util.MathUtil;

    /**
     * ...
     * @author Mike Meyer
     */
    public class BackgroundWoosh extends GameObject
    {
        private static const WIDTH:Number = 300;
        private static const HEIGHT:Number = 4;
        private static const STARTING_SPEED:Number = 5000.0;
        private static const COLORS:Array = [
            Colors.DESAT_BLUEGREEN,
            Colors.DESAT_CYAN,
            Colors.DESAT_BLUE,
            Colors.DESAT_DEEPBLUE,
            Colors.DESAT_PURPLE,
            Colors.DESAT_MAGENTA ];
        private static const ALPHAS:Array = [1.0, 0.75, 0.5, 0.25];

        public override function Init():void
        {
            super.Init();
            CreateGraphics();
            x = Global.StageWidth + width;
            y = Global.StageHeight * Math.random();
            dx = -STARTING_SPEED;
            alpha = Util.RandomOneOf(ALPHAS);
            PhysicsEnabled = false;
        }

        private function CreateGraphics():void
        {
            graphics.clear();
            var gradientMatrix:Matrix = new Matrix();
            gradientMatrix.createGradientBox( WIDTH, HEIGHT, 0.0, -0.5 * WIDTH, -0.5 * HEIGHT);
            var color:Number = Util.RandomOneOf(COLORS);
            graphics.beginGradientFill(
                GradientType.LINEAR,
                [color, color, color],
                [0.0, 1.0, 0.0],
                [0. * 255, 0.5 * 255, 1.0 * 255],
                gradientMatrix );
            graphics.drawRect(
                -0.5 * WIDTH,
                -0.5 * HEIGHT,
                WIDTH,
                HEIGHT );
            graphics.endFill();
        }

        public override function IsAlive():Boolean
        {
            return (x + width) > 0;
        }
    }

}
