﻿package gamespecific
{
    import flash.geom.Rectangle;
    import meyermike.core.GameObject;
    import meyermike.Global;
    import meyermike.Util;
    import meyermike.util.MathUtil;

    /**
     * ...
     * @author Mike Meyer
     */
    public class Bullet extends GameObject
    {
        private static const WIDTH:Number = 64;
        private static const HEIGHT:Number = 16;
        private static const COLORS:Array = [0xFFFFFF, 0x00FFFF, 0x0066FF, 0x0000FF];

        public override function Init():void
        {
            super.Init();
            CreateGraphics();
            PhysicsEnabled = false;
        }

        private function CreateGraphics():void
        {
            graphics.clear();
            graphics.beginFill( Util.RandomOneOf(COLORS) );
            graphics.drawRect(
                -0.5 * WIDTH,
                -0.5 * HEIGHT,
                WIDTH,
                HEIGHT );
            graphics.endFill();
        }

        public override function IsAlive():Boolean
        {
            var bounds:Rectangle = this.getBounds(root);
            return ( (bounds.left <= Global.StageWidth)
                   &&(bounds.top <= Global.StageHeight)
                   &&(bounds.right >= 0)
                   &&(bounds.bottom >= 0));
        }

    }

}
