﻿package gamespecific
{
    import flash.display.GradientType;
    import flash.geom.Matrix;
    import meyermike.constants.Colors;
    import meyermike.core.GameObject;
    import meyermike.Global;
    import meyermike.Util;
    import meyermike.util.MathUtil;
    import meyermike.widget.TextField;

    /**
     * ...
     * @author Mike Meyer
     */
    public class Enemy extends GameObject
    {
        private static const DEATH_SPIN:Number = 30.0;
        private static const SPEED:Number = 125.0;

        private var mDying:Boolean;
        public function get Dying():Boolean { return mDying; }
        public function set Dying(value:Boolean):void { mDying = value; }

        private var _text:String;
        public function get Text():String { return _text; }
        public function set Text(value:String):void
        {
            _text = value;
            mTextField.SetText(_text);
            dx = -SPEED;
            x = Global.StageWidth;
            PickGoodY();
            hp = _text.length;
        }

        /**
         * sneaky way to get the words distributed better in y
         */
        private static const MIN_DIST:Number = 20;
        private static const MAX_DIST:Number = 120;
        private static var sLastY:Number = 0;
        private function PickGoodY():void
        {
            var dist:Number;
            do
            {
                y = MathUtil.Lerp( 0.5 * height, (Global.StageHeight - 0.5 * height), Math.random() );
                dist = Math.abs(sLastY - y);
            } while ( (dist<MIN_DIST)||(dist>MAX_DIST) );

            sLastY = y;
        }

        private var _hp:Number = 1;
        public function get hp():Number { return _hp; }
        public function set hp(value:Number):void { _hp = value; if (0 >= _hp) { BeginDeath(); } else { mDying = false; } }

        private var mTextField:TextField;

        public override function Init():void
        {
            super.Init();
            CreateGraphics();
            _text = "";
            _hp = 1;
            dx = -SPEED;
            PhysicsEnabled = false;
            rotation = 0;
            dr = 0;
        }

        private function CreateGraphics():void
        {
            if (null == mTextField)
            {
                mTextField = InternalGameObjects.Add(TextField) as TextField;
                mTextField.SetFontColor(0xFFFFFF);
                mTextField.SetFontSize(14);
                mTextField.vAlign = TextField.VALIGN_MIDDLE;
            }
        }

        public override function IsAlive():Boolean
        {
            return ( (x + width) > 0 ) && ( y - height < Global.StageHeight );
        }

        public function BeginDeath():void
        {
            Dying = true;
            dx = Math.abs(dx);
            dy = dx;
            if (dy < 200) { dy = 200; }
            dr = DEATH_SPIN;
        }

        public override function Update(elapsedTime:Number):void
        {
            super.Update(elapsedTime);
        }
    }

}
