﻿package gamespecific
{
    import flash.display.GradientType;
    import flash.geom.Matrix;
    import meyermike.constants.Colors;
    import meyermike.core.GameObject;
    import meyermike.Global;
    import meyermike.Util;
    import meyermike.util.MathUtil;

    /**
     * ...
     * @author Mike Meyer
     */
    public class GroundWoosh extends GameObject
    {
        private static const WIDTH:Number = 500;
        private static const HEIGHT:Number = 8;
        private static const STARTING_SPEED:Number = 5000.0;

        private static const COLORS:Array = [0xC07830,0x783000,0xC07830 ];
        private static const ALPHAS:Array = [1.0,1.0,1.0];
        private static const RATIOS:Array = [0. * 255, 0.5 * 255, 1.0 * 255];

        public override function Init():void
        {
            super.Init();
            CreateGraphics();
            x = Global.StageWidth + width;
            y = Global.StageHeight - height;
            dx = -STARTING_SPEED;
            PhysicsEnabled = false;
        }

        private function CreateGraphics():void
        {
            graphics.clear();
            var gradientMatrix:Matrix = new Matrix();
            gradientMatrix.createGradientBox( WIDTH, HEIGHT, 0.0, 0, 0);
            graphics.beginGradientFill(
                GradientType.LINEAR,
                COLORS,
                ALPHAS,
                RATIOS,
                gradientMatrix );
            graphics.drawRect(
                0,
                0,
                WIDTH,
                HEIGHT );
            graphics.endFill();
        }

        public override function IsAlive():Boolean
        {
            return (x + width) > 0;
        }
    }

}
