﻿package gamespecific
{
    import flash.geom.Rectangle;
    import meyermike.core.GameObject;
    import meyermike.Global;
    import meyermike.Util;
    import meyermike.util.MathUtil;

    /**
     * ...
     * @author Mike Meyer
     */
    public class RocketFlame extends GameObject
    {
        private static const STARTING_SIZE:Number = 16;
        private static const COLORS:Array = [0xFFFFFF, 0xFFFF00, 0xFF6600, 0xFF0000];
        private static const LIFETIME:Number = 0.25;
        private var mLifeLeft:Number;

        public override function Init():void
        {
            super.Init();
            CreateGraphics();
            rotation = Math.random() * 360;
            PhysicsEnabled = false;
            mLifeLeft = LIFETIME;
        }

        private function CreateGraphics():void
        {
            graphics.clear();
            graphics.beginFill( Util.RandomOneOf(COLORS) );
            graphics.drawRect(
                -0.5 * STARTING_SIZE,
                -0.5 * STARTING_SIZE,
                STARTING_SIZE,
                STARTING_SIZE );
            graphics.endFill();
        }

        public override function Update(elapsedTime:Number):void
        {
            super.Update(elapsedTime);
            mLifeLeft -= elapsedTime;
        }

        public override function IsAlive():Boolean
        {
            if (mLifeLeft <= 0.0)
            {
                return false;
            }

            var bounds:Rectangle = this.getBounds(root);
            return ( (bounds.left <= Global.StageWidth)
                   &&(bounds.top <= Global.StageHeight)
                   &&(bounds.right >= 0)
                   &&(bounds.bottom >= 0));
        }
    }

}
