﻿package gamespecific.gamestates
{
    import flash.events.KeyboardEvent;
    import flash.events.MouseEvent;
    import meyermike.core.GameInterface;
    import meyermike.core.GameState;
    import meyermike.Global;
    import meyermike.script.Step;
    import meyermike.script.step.CreateGameObjectFromBitmap;
    import meyermike.script.step.Loop;
    import meyermike.script.step.Parallel;
    import meyermike.script.step.RunFunc;
    import meyermike.util.GuiBuilder;
    import meyermike.util.music.Song;
    import meyermike.widget.PulsingTextButton;
    import meyermike.widget.TextField;

    /**
     * ...
     * @author Mike Meyer
     */
    public class Title extends GameState
    {
        [Embed(source = '../assets/Intro0.png')]
        private static var Graphic1Class:Class;

        [Embed(source = '../assets/Intro1.png')]
        private static var Graphic2Class:Class;

        [Embed(source = '../assets/Intro2.png')]
        private static var Graphic3Class:Class;

        [Embed(source = '../assets/Intro3.png')]
        private static var Graphic4Class:Class;

        [Embed(source = '../assets/Intro4.png')]
        private static var Graphic5Class:Class;

        // set up the gamestate
        public override function Begin(game:GameInterface):void
        {
            super.Begin(game);

            var centerx:Number = 0.5 * Global.StageWidth;
            var centery:Number = 0.5 * Global.StageHeight;

            /*mScript = new Loop(1, [
                new CreateGameObjectFromBitmap(Game.Layers.UiLayer, Graphic1Class, centerx, centery ),
                new Parallel( [
                    new RunFunc(StartWatchingForClick),
                    new CreateGameObjectFromBitmap(Game.Layers.UiLayer, Graphic2Class, centerx, centery )]),
                new CreateGameObjectFromBitmap(Game.Layers.UiLayer, Graphic3Class, centerx, centery ),
                new CreateGameObjectFromBitmap(Game.Layers.UiLayer, Graphic4Class, centerx, centery ),
                new CreateGameObjectFromBitmap(Game.Layers.UiLayer, Graphic5Class, centerx, centery ) ]);
                */
            mScript = new Loop(1, [
                new CreateGameObjectFromBitmap(Game.Layers.UiLayer, Graphic5Class, centerx, centery ),
                new RunFunc(StartWatchingForClick) ]);
        }

        // clean up after yourself
        public override function End():void
        {
            super.End();

            Game.stage.removeEventListener(MouseEvent.CLICK, MouseClick);
            Game.Layers.RemoveAll();
        }

        /**
         * watch for the keypress that skips the intro
         */
        private function MouseClick(e:MouseEvent):void
        {
            Game.ChangeGameState(new PlanetSelect());
        }

        /**
         *
         */
        public function StartWatchingForClick():void
        {
            Game.stage.addEventListener(MouseEvent.CLICK, MouseClick);
        }
    }

}
