package meyermike.screen
{
    import flash.display.Sprite;
    import flash.events.Event;
    import meyermike.constants.Defaults;
    import meyermike.Global;
    import meyermike.widget.TextField;
    public class Pause extends Sprite
    {
        protected var mScreenColor:Number;
        protected var mFontColor:Number;
        protected var mAlpha:Number;
        protected var mFont:String;

        function Pause( screenColor:Number = -1,
                        alpha:Number = -1,
                        fontColor:Number = -1,
                        font:String = null)
        {
            super();

            mScreenColor = screenColor;
            if (-1 == mScreenColor) { mScreenColor = Defaults.PAUSE_SCREEN_COLOR; }

            mFontColor = fontColor;
            if (-1 == mFontColor) { mFontColor = Defaults.PAUSE_SCREEN_FONT_COLOR; }

            mAlpha = alpha;
            if ( -1 == mAlpha) { mAlpha = Defaults.PAUSE_SCREEN_ALPHA; }

            mFont = font;
            if (null == mFont) { mFont = Defaults.PAUSE_SCREEN_FONT; }

            if (stage)
            {
                Init();
            }
            else
            {
                addEventListener(Event.ADDED_TO_STAGE, Init);
            }
        }

        private function Init(e:Event = null):void
        {
            var w:Number = Global.StageWidth
            var h:Number = Global.StageHeight;

            this.graphics.beginFill( mScreenColor );
            // making it extra big to avoid camera shake artifacts.
            // for the future, some things should be unscrollable/unshakeable
            this.graphics.drawRect( -w, -h, 3.0 * w, 3.0 * h )
            this.graphics.endFill();
            this.alpha = mAlpha;
            this.visible = false;

            var pauseLabel:TextField = new TextField();
            pauseLabel.SetText("PAUSED");
            pauseLabel.SetFont(mFont);
            pauseLabel.SetFontSize(36);
            pauseLabel.SetFontColor(mFontColor);
            pauseLabel.CenterOn( 0.5 * w, 0.4 * h );
            this.addChild(pauseLabel);

            var clickInstructions:TextField = new TextField();
            clickInstructions.SetText("click to continue");
            clickInstructions.SetFont(mFont);
            clickInstructions.SetFontSize(16);
            clickInstructions.SetFontColor(mFontColor);
            clickInstructions.CenterOn( 0.5 * w, 0.7 *h );
            this.addChild(clickInstructions);
        }
    }
}
