package meyermike.script.step.animate
{
    import flash.display.DisplayObject;
    import meyermike.util.MathUtil;
    public class AnimationValues
    {
        private var _animateAlpha:Boolean = false;
        private var _alpha:Number;
        public function get AnimateAlpha():Boolean { return _animateAlpha;}
        public function get alpha():Number { return _alpha; }
        public function set alpha(value:Number):void { _animateAlpha = true; _alpha = value; }

        /**
         * make a new AnimationValues object from an object
         */
        public static function BuildFromObject(values:Object):AnimationValues
        {
            var av:AnimationValues = new AnimationValues();

            for (var property:String in values)
            {
                switch (property)
                {
                    case "alpha":
                        av.alpha = values[property];
                        break;
                    default:
                        throw new Error("unrecognized property:  \"" + property + "\"");
                        break;
                }
            }

            return av;
        }

        /**
         * Lerp a DisplayObject's properties
         * @param	start
         * @param	end
         * @param	time
         * @param	duration
         */
        public static function AnimateBetween(
            target:DisplayObject,
            start:AnimationValues,
            end:AnimationValues,
            time:Number,
            duration:Number):void
        {
            var t:Number = time / duration;
            t = MathUtil.Clamp(t, 0, 1);

            if (start.AnimateAlpha)
            {
                target.alpha = MathUtil.Lerp(start.alpha, end.alpha, t);
            }
        }
    }
}
